import pygame, pak, sys, map, shapes, logic, math

now=0
state=0

def veil(x,y,w,h,i,l):
    sf = pygame.surface.Surface((w, h))
    sf.fill((0,0,0,0))
    sf.convert()
    sf.set_alpha(255)
    r = sf.get_rect()
    r.x=x
    r.y=y
    return [sf, r, 255, i, l]
def update_veil(v):
    if v[2] > 0:
        v[2]=v[2]-1
    v[0].set_alpha(v[2])

def init():
    global screen
    global background
    global bgrect
    global whistle
    global train
    global wagon
    pygame.init()
    screen = pygame.display.set_mode((800, 600), pygame.FULLSCREEN)
    pygame.mouse.set_visible(False)
    background=pak.unpak("menu.pak")[0]
    bgrect=background.get_rect()
    bgrect.x=0
    bgrect.y=0
    whistle=pygame.mixer.Sound("train1.wav")
    train = pygame.image.load("loc.bmp")
    map.init()
    shapes.init()
    wagon = shapes.myfont.render("enter to enter -  escape to escape -", True, shapes.brown)
    reset_menu()
def reset_game():
    global game
    global counter
    game = logic.GameState(8,12)
    pygame.mixer.music.load("mainsong.ogg")
    pygame.mixer.music.play(-1)
    counter=0
def reset_menu():
    global veils
    global now
    pygame.mixer.music.load("introsong.ogg")
    pygame.mixer.music.play(-1)
    now=pygame.time.get_ticks()
    veils=[veil(100, 90, 250, 100, 0, now), #super
       veil(350, 60, 120, 100, 3333, now), #fun
       veil(477, 64, 200, 150, 6666, now), #tastic
       veil(100,190,240,100,9999,now), #loco
       veil(340,200,260,100,13332,now), #motive
       veil(297,300,161,100,16665,now) #ride
       ]
def events_menu():
    global state
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            sys.exit()
        if event.type == pygame.KEYDOWN:
            key = event.key
            if key == pygame.K_RETURN:
                state=1
                reset_game()
            if key == pygame.K_ESCAPE:
                sys.exit()
def events_game():
    for event in pygame.event.get():
        if event.type==pygame.QUIT:
            sys.exit()
        if event.type==pygame.KEYDOWN:
            key=event.key
            if key==pygame.K_ESCAPE:
                sys.exit()
            if key==pygame.K_SPACE:
                game.toggle_switch()
            if key==pygame.K_w:
                whistle.play()
def update_menu():
    pass
def draw_menu():
    now=pygame.time.get_ticks()
    screen.fill((0,0,0,0))
    screen.blit(background, bgrect)
    for i in veils:
        screen.blit(i[0], i[1])
        if now > i[3]:
            if (now-i[4]) > 10:
                update_veil(i)
                i[4]=now
    screen.blit(wagon,(0,450))
    screen.blit(train,(wagon.get_width(),440))
    shapes.draw_text("c 2006 EpsilonDelta. There is no escaping it!",200,570,shapes.brown,screen)
    
def update_game():
    global counter
    global now
    global state
    now=pygame.time.get_ticks()
    game.update()
    if(not game.crashed):
        map.update(now)
    if(game.game_over):
        state=0
        reset_menu()
    counter=counter+1
def draw_game():
    global now
    x=25
    screen.fill(shapes.black)
    shapes.clear()
    map.draw(screen)
    for track in game.tracks:
        y=550
        for i in track:
            if i in [1,2,3,7,8]:
                shapes.draw_track(x,y,50)
            if i == 4:
                shapes.draw_pool(x-50,y,50)
            if i == 6:
                shapes.draw_track_end(x,y,50)
            y=y-50
        x=x+100
    x=25
    for track in game.tracks:
        y=550
        for i in track:
            if i == 2:
                shapes.draw_left_switch(x,y,not(game.get_direction()==0),50)
            if i == 3:
                shapes.draw_right_switch(x,y,not(game.get_direction()==0),50)
            y=y-50
            if i == 7:
                shapes.draw_life_bonus(x,y)
            if i == 8:
                shapes.draw_score_bonus(x,y)
        x=x+100
    shapes.draw_loc(25+game.get_train_position()*100,400,counter%30,50)
    shapes.draw_text("Score: " + str(game.score) + " Lives: " + str(game.lives) + " Time: " + str(now/1000) +"s",5,10,shapes.brown,screen)
    shapes.update(screen)

init()
while True:
    if(state==1):
        events_game()
        update_game()
        draw_game()
    if(state==0):
        events_menu()
        update_menu()
        draw_menu()
    pygame.display.flip()
