import pygame, pak, sys, math, map, logic

black=(0,0,0)
lighter_black=(40,40,40)
brown=(102, 51, 0)
dark_brown=(51,26,0)
blue=(0,0,255)
light_gray=(240,240,240)
gray=(128,128,128)
dark_gray=(64,64,64)
green = (0,100,0)
transparent = (1,1,1)
log_width=40.0
track_height=100
log_gap=10.0
log_height=10.0

def init():
    global myfont
    global main_surface
    global life_bonus
    global score_bonus
    global signs
    main_surface=pygame.Surface((800,600))
    main_surface.fill((1,1,1))
    main_surface.set_colorkey(transparent)
    main_surface.convert()
    life_bonus=pygame.image.load("loc.bmp").convert()
    life_bonus.set_colorkey(black)
    score_bonus=pygame.image.load("bonus.bmp").convert()
    score_bonus.set_colorkey(black)
    signs=pygame.image.load("signs.bmp").convert()
    signs.set_colorkey(black)
    myfont=pygame.font.Font("font.ttf",20)
def draw_text(text,x,y,color,screen):
    screen.blit(myfont.render(text,True,color),(x,y))
def draw_track_log(x,y):
    pygame.draw.rect(main_surface,brown,(x,y, int(log_width), int(log_height)),0)
def draw_track(x,y,h):
    draw_track_log(x,y+5)
    draw_track_log(x,y+20)
    draw_track_log(x,y+35)
    x=x+int(log_width/3)
    pygame.draw.line(main_surface,light_gray,(x,y),(x,y+h),1)
    pygame.draw.line(main_surface,gray,(x+1,y),(x+1,y+h),1)
    pygame.draw.line(main_surface,dark_gray,(x+2,y),(x+2,y+h),1)
    x=x+int(log_width/3)
    pygame.draw.line(main_surface,light_gray,(x,y),(x,y+h),1)
    pygame.draw.line(main_surface,gray,(x+1,y),(x+1,y+h),1)
    pygame.draw.line(main_surface,dark_gray,(x+2,y),(x+2,y+h),1)
def draw_track_end(x,y,h):
    rect=pygame.draw.rect(main_surface,dark_brown,(x,y,int(log_width), h),0)
    pygame.draw.rect(main_surface,brown,(x,y,int(log_width), h),1)
    pygame.draw.line(main_surface,brown,(rect.left,rect.top),(rect.right,rect.bottom),1)
    pygame.draw.line(main_surface,brown,(rect.right,rect.top),(rect.left,rect.bottom),1)
def draw_left_switch(x,y,on,h):
    if(on):
        main_surface.blit(signs, (x+40,y), (32,0,32,32))
    else:
        main_surface.blit(signs, (x+40,y), (0,0,32,32))
    pygame.draw.arc(main_surface,gray,(x-100,y+int(h/2.0)+1,int(log_width/3)+102,h),0,1.6,2)
    pygame.draw.arc(main_surface,gray,(x-100+int(log_width/3),y-int(h/2.0)+3,100,h),-3.141,-1.5,2)
    pygame.draw.arc(main_surface,gray,(x-100+int(log_width/3),y+int(h/2.0)+1-int(log_width/3),int(log_width/3)+102,h),0,1.6,2)
    pygame.draw.arc(main_surface,gray,(x-100+int(2*log_width/3),y-int(h/2.0)+3-int(log_width/3),100,h),-3.141,-1.5,2)
def draw_right_switch(x,y,on,h):
    if(on):
        main_surface.blit(signs, (x+40,y), (64,0,32,32))
    else:
        main_surface.blit(signs, (x+40,y), (0,0,32,32))
    pygame.draw.arc(main_surface,gray,(x+int(2*log_width/3),y+int(h/2.0)+1,100,h),1.5,3.141,2)
    pygame.draw.arc(main_surface,gray,(x+int(2*log_width/3)+2,y-int(h/2.0)+3,100,h),-1.6,0,2)
    pygame.draw.arc(main_surface,gray,(x+int(log_width/3),y+int(h/2.0)+1-int(log_width/3),100,h),1.5,3.141,2)
    pygame.draw.arc(main_surface,gray,(x+int(log_width/3)+2,y-int(h/2.0)+3-int(log_width/3),100,h),-1.6,0,2)
def draw_pool(x,y,h):
    pygame.draw.ellipse(main_surface, blue, (x,y,log_width+100,h),0)
def draw_loc(x,y,smoke,h):
    pygame.draw.rect(main_surface,lighter_black,(x,y,40,25)) #draw driver's cabin
    pygame.draw.rect(main_surface,black,(x,y,40,25),1) #rim driver's cabin
    pygame.draw.rect(main_surface,lighter_black,(x+10,y-20,20,20)) #draw engine
    pygame.draw.circle(main_surface,lighter_black,(x+20,y-20),10)
    pygame.draw.circle(main_surface,black,(x+20,y-15),5,1) #draw chimney
    pygame.draw.circle(main_surface,(120+smoke,120+smoke,120+smoke),(x+20-smoke,y-15),5)
def draw_score_bonus(x,y):
    main_surface.blit(score_bonus, (x,y))
def draw_life_bonus(x,y):
    main_surface.blit(life_bonus, (x,y))
def clear():
    main_surface.fill(transparent)
def update(screen):
    screen.blit(main_surface,(0,32))

#what follows is a simple game framework for testing:
#pygame.init()
#screen = pygame.display.set_mode((800, 600), pygame.FULLSCREEN)
#pygame.mouse.set_visible(False)
#draw_map=True
#map.init()
#init()
#game = logic.GameState(8,12)
#pygame.mixer.music.load("mainsong.ogg")
#pygame.mixer.music.play(-1)
#counter=0
#while True:
#    for event in pygame.event.get():
#        if event.type == pygame.QUIT:
#            sys.exit()
#        if event.type == pygame.KEYDOWN:
#            key = event.key
#            if key == pygame.K_ESCAPE:
#                sys.exit()
#            if key == pygame.K_SPACE:
#                game.toggle_switch()
#    now=pygame.time.get_ticks()
#    if(not game.crashed):
#        map.update(now)
#    #draw things:
#    screen.fill(black)
#    clear()
#    if(draw_map):
#       map.draw(screen)
#    game.update()
#    x=25
#    for track in game.tracks:
#        y=550
#        for i in track:
#            if i in [1,2,3,7,8]:
#                draw_track(x,y,50)
#    pygame.time.delay(10)
#    counter=counter+1
